/*
 * display.c
 *
 *  Created on: Jul 24, 2016
 *      Author: esp8266
 */

#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <lcd.h>
#include "mode.h"
#include "scanner.h"
#include "display.h"

static char linebuf[LCD_DISP_LENGTH + 1];

void print_mode(const mode_t *p_mode)
{
	memcpy(linebuf, "    :   ", sizeof(linebuf));
	char num_buf[6];

	itoa((int) (p_mode->period), num_buf, 10);
	memcpy(linebuf, num_buf, strlen(num_buf));

	itoa((int) (p_mode->width), num_buf, 10);
	memcpy(linebuf + 5, num_buf, strlen(num_buf));

	lcd_puts(linebuf);
}

void print_modes(const mode_t *p_modes, uint8_t count)
{
	for (int i = 0; i < count; ++i)
	{
		uint8_t x = (i + 1) % 2 * 8;
		uint8_t y = ((i + 1) / 2);
		lcd_gotoxy(x, y);
		print_mode(&p_modes[i]);
	}
}

void print_scanned_mode(const mode_t *p_mode)
{
	lcd_gotoxy(0, 0);
	print_mode(p_mode);
}

void print_chase(const uint16_t period, const uint16_t min_period,
		const uint16_t max_period)
{
	lcd_gotoxy(0, 0);
	itoa(period, linebuf, 10);
	lcd_puts(linebuf);
	lcd_puts("   ");

	lcd_gotoxy(8, 0);
	itoa(min_period, linebuf, 10);
	lcd_puts(linebuf);
	lcd_puts("   ");

	lcd_gotoxy(0, 1);
	itoa(min_period + ((max_period - min_period) / 2), linebuf, 10);
	lcd_puts(linebuf);
	lcd_puts("   ");

	lcd_gotoxy(8, 1);
	itoa(max_period, linebuf, 10);
	lcd_puts(linebuf);
	lcd_puts("   ");
}
