/*
 * oscillator.c
 *
 *  Created on: Jul 23, 2016
 *      Author: esp8266
 */
#include <avr/io.h>
#include <util/delay.h>
#include "oscillator.h"

void osc_init()
{
	DDRD |= (1 << PD5);

	TCCR1A = (0 << COM1A1) // Toggle OC1A (PD5) on compare match
			| (1 << COM1A0) //
			| (0 << COM1B1) // OC1B disconnected
			| (0 << COM1B0) //
			| (0 << FOC1A) //
			| (0 << FOC1B) //
			| (0 << WGM11) //
			| (0 << WGM10) //
			;

	TCCR1B = (0 << ICNC1) //
			| (0 << ICES1) //
			| (0 << WGM13) //
			| (1 << WGM12) //

			| (0 << CS12) // Clock Select clk_io / 1
			| (0 << CS11) //
			| (0 << CS10) //
			;
}

void osc_set_period(const uint16_t half_wave_duration)
{
	OCR1A = half_wave_duration;
	_delay_ms(5);
}

void osc_enable(const uint8_t on)
{
	if (on)
	{
		TCCR1B |= (0 << CS12) // Clock Select clk_io / 1
				| (0 << CS11) //
				| (1 << CS10) //
				;
	}
	else
	{
		TCCR1B &= ~(
				(1 << CS12) // Clock Select off
				| (1 << CS11) //
				| (1 << CS10) //
		);
	}
}
